From e10bd0722c4005674af82d605ae7fc3e3f1f9dc3 Mon Sep 17 00:00:00 2001
From: Bansidhar Gopalachari <bansid@codeaurora.org>
Date: Fri, 22 Aug 2014 11:23:39 -0700
Subject: [PATCH] SBA 4.3.6.106 on top of 4.3.6.105

Change-Id: Id7719a97dc0b73e70cdd234d7fa6f18667e5fc23
---
 CORE/MAC/inc/qwlan_version.h     |  4 ++--
 CORE/SERVICES/HTC/htc.c          |  2 ++
 CORE/SERVICES/HTC/htc_internal.h | 17 +++++++++++++++++
 CORE/SERVICES/HTC/htc_send.c     | 31 ++++++++++++++++++++++++++++++-
 4 files changed, 51 insertions(+), 3 deletions(-)

diff --git a/CORE/MAC/inc/qwlan_version.h b/CORE/MAC/inc/qwlan_version.h
index 107c71d..0cccf86 100644
--- a/CORE/MAC/inc/qwlan_version.h
+++ b/CORE/MAC/inc/qwlan_version.h
@@ -42,9 +42,9 @@ BRIEF DESCRIPTION:
 #define QWLAN_VERSION_MINOR            3
 #define QWLAN_VERSION_PATCH            6
 #define QWLAN_VERSION_EXTRA            ""
-#define QWLAN_VERSION_BUILD            105
+#define QWLAN_VERSION_BUILD            106
 
-#define QWLAN_VERSIONSTR               "4.3.6.105"
+#define QWLAN_VERSIONSTR               "4.3.6.106"
 
 #ifdef QCA_WIFI_2_0
 
diff --git a/CORE/SERVICES/HTC/htc.c b/CORE/SERVICES/HTC/htc.c
index 02cd766..24c72fc 100644
--- a/CORE/SERVICES/HTC/htc.c
+++ b/CORE/SERVICES/HTC/htc.c
@@ -180,6 +180,7 @@ static void HTCCleanup(HTC_TARGET *target)
     adf_os_spinlock_destroy(&target->HTCLock);
     adf_os_spinlock_destroy(&target->HTCRxLock);
     adf_os_spinlock_destroy(&target->HTCTxLock);
+    adf_os_spinlock_destroy(&target->HTCCreditLock);
 
     /* free our instance */
     A_FREE(target);
@@ -208,6 +209,7 @@ HTC_HANDLE HTCCreate(void *ol_sc, HTC_INIT_INFO *pInfo, adf_os_device_t osdev)
     adf_os_spinlock_init(&target->HTCLock);
     adf_os_spinlock_init(&target->HTCRxLock);
     adf_os_spinlock_init(&target->HTCTxLock);
+    adf_os_spinlock_init(&target->HTCCreditLock);
 
     do {
         A_MEMCPY(&target->HTCInitInfo,pInfo,sizeof(HTC_INIT_INFO));
diff --git a/CORE/SERVICES/HTC/htc_internal.h b/CORE/SERVICES/HTC/htc_internal.h
index 3e3412f..643f628 100644
--- a/CORE/SERVICES/HTC/htc_internal.h
+++ b/CORE/SERVICES/HTC/htc_internal.h
@@ -86,6 +86,20 @@ extern "C" {
 
 #define HTC_SERVICE_TX_PACKET_TAG  HTC_TX_PACKET_TAG_INTERNAL
 
+#define HTC_CREDIT_HISTORY_MAX              1024
+
+typedef enum {
+    HTC_REQUEST_CREDIT,
+    HTC_PROCESS_CREDIT_REPORT,
+} htc_credit_exchange_type;
+
+typedef struct {
+    htc_credit_exchange_type type;
+    A_UINT64 time;
+    A_UINT32 tx_credit;
+    A_UINT32 htc_tx_queue_depth;
+} HTC_CREDIT_HISTORY;
+
 typedef struct _HTC_ENDPOINT {
     HTC_ENDPOINT_ID             Id;
     HTC_SERVICE_ID              ServiceID;          /* service ID this endpoint is bound to
@@ -146,6 +160,7 @@ typedef struct _HTC_TARGET {
     adf_os_spinlock_t           HTCLock;
     adf_os_spinlock_t           HTCRxLock;
     adf_os_spinlock_t           HTCTxLock;
+    adf_os_spinlock_t           HTCCreditLock;
     A_UINT32                    HTCStateFlags;
     void                       *host_handle;
     HTC_INIT_INFO               HTCInitInfo;
@@ -189,6 +204,8 @@ typedef struct _HTC_TARGET {
 #define UNLOCK_HTC_RX(t)        adf_os_spin_unlock_bh(&(t)->HTCRxLock);
 #define LOCK_HTC_TX(t)          adf_os_spin_lock_bh(&(t)->HTCTxLock);
 #define UNLOCK_HTC_TX(t)        adf_os_spin_unlock_bh(&(t)->HTCTxLock);
+#define LOCK_HTC_CREDIT(t)      adf_os_spin_lock_bh(&(t)->HTCCreditLock);
+#define UNLOCK_HTC_CREDIT(t)    adf_os_spin_unlock_bh(&(t)->HTCCreditLock);
 
 #define GET_HTC_TARGET_FROM_HANDLE(hnd) ((HTC_TARGET *)(hnd))
 
diff --git a/CORE/SERVICES/HTC/htc_send.c b/CORE/SERVICES/HTC/htc_send.c
index bde183e..39ebb4d 100644
--- a/CORE/SERVICES/HTC/htc_send.c
+++ b/CORE/SERVICES/HTC/htc_send.c
@@ -60,6 +60,20 @@ static unsigned ep_debug_mask = (1 << ENDPOINT_0) | (1 << ENDPOINT_1) | (1 << EN
 #define ENABLE_BUNDLE_TX 0
 #endif
 
+/* HTC Control Path Credit History */
+A_UINT32 g_htc_credit_history_idx = 0;
+HTC_CREDIT_HISTORY htc_credit_history_buffer[HTC_CREDIT_HISTORY_MAX];
+
+#define HTC_CREDIT_RECORD(a, b, c) {                                           \
+  if (HTC_CREDIT_HISTORY_MAX <= g_htc_credit_history_idx)                      \
+    g_htc_credit_history_idx = 0;                                              \
+  htc_credit_history_buffer[g_htc_credit_history_idx].type = a;                \
+  htc_credit_history_buffer[g_htc_credit_history_idx].time =                   \
+    adf_get_boottime();                                                        \
+  htc_credit_history_buffer[g_htc_credit_history_idx].tx_credit = b;           \
+  htc_credit_history_buffer[g_htc_credit_history_idx].htc_tx_queue_depth = c;  \
+  g_htc_credit_history_idx++;                                                  \
+}                                                                              \
 
 void HTC_dump_counter_info(HTC_HANDLE HTCHandle)
 {
@@ -685,8 +699,16 @@ void GetHTCSendPacketsCreditBased(HTC_TARGET        *target,
 
                 /* check if we need credits back from the target */
             if (pEndpoint->TxCredits <= pEndpoint->TxCreditsPerMaxMsg) {
-                    /* tell the target we need credits ASAP! */
+                /* tell the target we need credits ASAP! */
                 sendFlags |= HTC_FLAGS_NEED_CREDIT_UPDATE;
+
+                if (pEndpoint->ServiceID == WMI_CONTROL_SVC) {
+                    LOCK_HTC_CREDIT(target);
+                    HTC_CREDIT_RECORD(HTC_REQUEST_CREDIT, pEndpoint->TxCredits,
+                        HTC_PACKET_QUEUE_DEPTH(&pEndpoint->TxQueue));
+                    UNLOCK_HTC_CREDIT(target);
+                }
+
                 INC_HTC_EP_STAT(pEndpoint, TxCreditLowIndications, 1);
 #if DEBUG_CREDIT
                 AR_DEBUG_PRINTF(ATH_DEBUG_ERR,(" EP%d Needs Credits\n", pEndpoint->Id));
@@ -1698,6 +1720,13 @@ void HTCProcessCreditRpt(HTC_TARGET *target, HTC_CREDIT_REPORT *pRpt, int NumEnt
 #else
         pEndpoint->TxCredits += rpt_credits;
 
+        if (pEndpoint->ServiceID == WMI_CONTROL_SVC) {
+            LOCK_HTC_CREDIT(target);
+            HTC_CREDIT_RECORD(HTC_PROCESS_CREDIT_REPORT, pEndpoint->TxCredits,
+                              HTC_PACKET_QUEUE_DEPTH(&pEndpoint->TxQueue));
+            UNLOCK_HTC_CREDIT(target);
+        }
+
         if (pEndpoint->TxCredits && HTC_PACKET_QUEUE_DEPTH(&pEndpoint->TxQueue)) {
             UNLOCK_HTC_TX(target);
 #ifdef ATH_11AC_TXCOMPACT
-- 
1.8.2.1

